-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "main"
M.relevantDevice = nil
M.engineInfo = {
  0,
  10000,
  0,
  0,
  0,
  "A",
  0,
  0,
  0,
  0,
  0,
  1,
  --electrics.values.fuelVolume
  1,
  --electrics.values.fuelCapacity
  "manual",
  obj:getID(),
  0,
  0,
  1,
  1
}
M.fireEngineTemperature = 0
M.throttle = 0
M.brake = 0
M.clutchRatio = 0
local function onReset()
  electrics.values['swivelJoint'] = 0
  electrics.values['swivelJoint_input'] = 0
  
  electrics.values['hook_movement'] = 0
  electrics.values['hook_movement_input'] = 0
  
  electrics.values['hook_cable'] = 0
  electrics.values['hook_cable_input'] = 0
end

local function updateGFX(dt) -- ms
  electrics.values['swivelJoint'] = math.min(1, math.max(-0.0, (electrics.values['swivelJoint'] + electrics.values['swivelJoint_input'] * dt * 0.08)))
  electrics.values['hook_movement'] = math.min(1, math.max(-0.0, (electrics.values['hook_movement'] + electrics.values['hook_movement_input'] * dt * 0.08)))
  electrics.values['hook_cable'] = math.min(1, math.max(-0.0, (electrics.values['hook_cable'] + electrics.values['hook_cable_input'] * dt * 0.08)))
end

local function swivelJointInp(value)
  electrics.values.swivelJoint_input = value
end

local function hook_movementInp(value)
  electrics.values.hook_movement_input = value
end

local function hook_cable_Inp(value)
  electrics.values.hook_cable_input = value
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.swivelJointInp = swivelJointInp
M.hook_movementInp = hook_movementInp
M.hook_cable_Inp = hook_cable_Inp

return M
